<?php
class CleanTalk_Base_CleanTalk {
    static public function getCheckjsName() {
	return 'ct_checkjs';
    }
    
    public static function hookAdminSettings(XenForo_Visitor &$visitor )
    {
		if (
                        sizeof($_POST) > 0 &&
                        isset($_POST['options']) &&
                        isset($_POST['options']['cleantalk']) &&
                        isset($_POST['options']['cleantalk']['apikey']) &&
                        !empty($_POST['options']['cleantalk']['apikey'])
                )
		{
			require_once 'CleanTalk/Base/cleantalk.class.php';
			$ct_ws = array(
				'work_url' => 'http://moderate.cleantalk.org',
				'server_url' => 'http://moderate.cleantalk.org',
				'server_ttl' => 0,
				'server_changed' => 0
			    );
			$ct = new Cleantalk();
			$ct->work_url = $ct_ws['work_url'];
			$ct->server_url = $ct_ws['server_url'];
			$ct->server_ttl = $ct_ws['server_ttl'];
			$ct->server_changed = $ct_ws['server_changed'];

			$ct_request = new CleantalkRequest();
			$ct_request->auth_key = $_POST['options']['cleantalk']['apikey'];
        		$ct_request->feedback = '0:xenforo-18';
        		$ct->sendFeedback($ct_request);
		}
    }
    
    /** Return Array of JS-keys for checking
	*
	* @return Array
	*/
	static public function getCheckJSArray() {
		$options = XenForo_Application::getOptions();
        $result=Array();
        for($i=-5;$i<=1;$i++) {
            $result[]=md5($options->get('cleantalk', 'apikey') . '+' . $options->get('contactEmailAddress') . date("Ymd",time()+86400*$i));
        }
        return $result;
	}

    static public function getCheckjsDefaultValue() {
	return '0';
    }

    static public function getCheckjsValue() {
	$options = XenForo_Application::getOptions();
	return md5($options->get('cleantalk', 'apikey') . '+' . $options->get('contactEmailAddress') . date("Ymd",time()));
    }

    public static function getTemplateAddon() {
	static $show_flag = TRUE;
	$ret_val = '';
	$options = XenForo_Application::getOptions();

	if ($show_flag) {
	    $show_flag = FALSE;
	    $field_name = self::getCheckjsName();
	    $ct_check_def = self::getCheckjsValue();
	    $ct_check_value = self::getCheckjsValue();
	    $js_template = '<script>
function ctSetCookie(c_name, value) {
	document.cookie = c_name + "=" + escape(value) + "; path=/";
}

setTimeout(function(){
	ctSetCookie("%s", "%s");
	ctSetCookie("ct_timezone", d.getTimezoneOffset()/60);
},1000);

//Stop observing function
function ctMouseStopData(){
	window.removeEventListener("mousemove", func);
	clearInterval(ctMouseReadInterval);
	clearInterval(ctMouseWriteDataInterval);				
}

var d = new Date(), 
	ctTimeMs = new Date().getTime(),
	ctMouseEventTimerFlag = true, //Reading interval flag
	ctMouseData = "[",
	ctMouseDataCounter = 0;
	
//Reading interval
var ctMouseReadInterval = setInterval(function(){
		ctMouseEventTimerFlag = true;
	}, 300);
	
//Writting interval
var ctMouseWriteDataInterval = setInterval(function(){ 
		var ctMouseDataToSend = ctMouseData.slice(0,-1).concat("]");
		ctSetCookie("ct_pointer_data", ctMouseDataToSend);
	}, 3000);

//Logging mouse position each 300 ms
var func = function output(event){
	if(ctMouseEventTimerFlag == true){
		var mouseDate = new Date();
		ctMouseData += "[" + event.pageY + "," + event.pageX + "," + (mouseDate.getTime() - ctTimeMs) + "],";
		ctMouseDataCounter++;
		ctMouseEventTimerFlag = false;
		if(ctMouseDataCounter >= 100)
			ctMouseStopData();
	}
}

if(typeof window.addEventListener == "function")
	window.addEventListener("mousemove", func);
else
	window.attachEvent("onmousemove", func);

</script>';
	    $ret_val = sprintf($js_template, $field_name, $ct_check_value);
	    if($options->get('cleantalk', 'link'))
	    {
	    	$ret_val.="<div style='width:100%;text-align:center'><a href='https://cleantalk.org/xenforo-antispam-addon'>XenForo spam</a> blocked by CleanTalk.</div>";
	    }
	}
//	XenForo_Application::getSession()->set('ct_submit_comment_time', time()); - got error 'The session has been saved and is now read-only'
//	XenForo_Application::setSimpleCacheData('ct_submit_comment_time', time());
	return $ret_val;
    }

}
